config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }
  resources :couples, except: [:index, :new]
  resources :verification_codes
  resources :scores, except: [:index]
  resources :match_players, except: [:new, :index, :edit]
  resources :matches, except: [:index, :destroy, :edit]
  resources :events
  
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "events#dashboard"

  # route for a new match-player with a specific event
  get 'match_players/new/:id', to: "match_players#new", as: 'new_match_player'
  get "match_players/edit/:id/(:resend)", to: "match_players#edit", as: "edit_match_player"
  # route to show the players for a specific event
  get 'match_players/index/:id', to: "match_players#index", as: 'players_enrolled'

  
  
  get 'matches/index/:id/(:round)', to: "matches#index", as: 'event_matches'
  get 'matches/player_matches/:event_id/:player_id', to: "matches#player_matches", as: 'player_matches'
  delete "matches/:event_id/:round", to: "matches#destroy", as: "matches_destroy_round"
  get 'matches/create_round_of_matches/:event_id', to: "matches#create_round_of_matches", as: 'create_round_of_matches'
  
  patch "events/update_status/:id", to: "events#update_status", as: "update_status_event"
  get "event/show_closed_event/:id", to: "events#show_closed_event", as: "show_closed_event"
  get "matches/edit/:id/:round", to: "matches#edit", as: "edit_match"
  get "scores/index/:id", to: "scores#index", as: "player_scores"
  
  get "players/new/(:event_id)", to: "players#new", as: "new_player"
  resources :players, except: [:new]
  
  #resources :players do
  #  get "players/new/(:event_id)", to: "players#new", as: "new_player", on: :collection
  #end
  
  get 'couples/index/:id', to: "couples#index", as: 'event_couples'
  get "couples/new/:id", to: "couples#new", as: "new_couple"
  get "players/dashboard/:player_id", to:  "players#dashboard", as: "dashboard_player"
  get "events/dashboard", to: "events#dashboard", as: "dashboard_events"
  #comment x
end 

app/models/player.rb
class Player < ApplicationRecord
    CATEGORY= %w[1 2 3 4 5] 
    has_many :events
    has_many :MatchPlayers
    has_many :VerificationCodes
    validates :cellphone, uniqueness: true
    attribute  :totalScore, default: 0
    attribute  :eventScore, default: 0
    has_one_attached :image
    has_many :results
    has_many :scores
    has_one :user

    #scope :de_cliente, -> (cliente) { where("cliente_id = ?", cliente) }
    #scope :ready_to_mate, -> { from_event.where("price > 500") }
    validates_format_of :cellphone, :with => /[0-9]{3}[0-9]{3}[0-9]{4}/, :message => "numbers must be in xxx-xxx-xxxx format."

    def self.ready_to_mate(event_id)
        event = Event.find(event_id)
        enrolled = event.match_player.where(status: "OnBoard").collect{|mp| mp.player }
        couples = event.couples
        players_not_elegible = couples.collect{|c| c.mate} + couples.collect{|c| c.player}
        return  enrolled.select{|p| p if players_not_elegible.exclude?(p)}
    end

    def updateTotalScore 
        #Compute all the gainned points and update the totalScore field
        total_score = Score.where(player_id: self.id).sum(:points)#Score.where(player_id: self.id).collect{|score| score.points }.sum
        self.totalScore = total_score
        self.save!
    end

    def age 
        #return the age of the player
        return ((Time.zone.now - self.birthDate.to_time) / 1.year.seconds).floor
    end
    
    def eventsPlayed 
        return MatchPlayer.where(player_id: self.id).count
    end
    
    def average 
        # return the mean points per event
        average = 0
        scores_p2 = Score.where(player_id: self.id)
        if !scores_p2.empty?
            point_scores_p2=scores_p2.collect{|s| s.points}
            average = (point_scores_p2.reduce(:+).to_f / point_scores_p2.size).to_i
        end
        return average
    end

    def generalRank
        #return the rank over all the players
        rank=0
        players = Player.all
        players.each{ |p|
            if p.totalScore.nil?
                p.updateTotalScore            
            end
        }

        rankings=Player.pluck(:id, :totalScore)
        
        rankings.sort_by{|totalScore|
            rank+=1
            break if totalScore[0]== self.id
        }
        #puts "The rank for the player id -> #{self.id} is -> #{rank}"
        return rank
    end

    def categoryRank
        #return the rank over your category
        rank=0
        category = self.category
        players = Player.all.where(category: category)
        players.each{ |p|
            if p.totalScore.nil?
                p.updateTotalScore
            end
        }

        players = Player.all.where(category: category)
        rankings=players.pluck(:id, :totalScore)
        
        rankings.sort_by{|totalScore|
            rank+=1
            break if totalScore[0]== self.id
        }
        #puts "The rank for the player id -> #{self.id} is -> #{rank}"
        return rank
    end
    def won_lost_draw_matches(event_id = nil) 
        #return a dictionary with the total number of won|lost|tied matches

        won_lost_draw = {total: 0, won: 0, lost: 0, tied: 0}
        
        #We count the matches result whe the player is PlayerOne or Two
        if event_id.nil?
            matches = Match.where(playerOne: self.id).or(Match.where(playerTwo: self.id))
        else
            matches = Match.where(playerOne: self.id, event_id: event_id).or(Match.where(playerTwo: self.id, event_id: event_id))
        end
        
        matches.each{|m|
            if m.pointsOne == m.pointsThree
                won_lost_draw[:tied] = won_lost_draw[:tied] + 1
            elsif m.pointsOne > m.pointsThree
                won_lost_draw[:won] = won_lost_draw[:won] + 1
            elsif m.pointsOne < m.pointsThree
                won_lost_draw[:lost] = won_lost_draw[:lost] + 1
            end
        }

        #We count the matches result whe the player is PlayerThree or Four
        if event_id.nil?
            matches = Match.where(playerThree: self.id).or(Match.where(playerFour: self.id))
        else
            matches = Match.where(playerThree: self.id, event_id: event_id).or(Match.where(playerFour: self.id, event_id: event_id))
        end
        matches.each{|m|
            if m.pointsOne == m.pointsThree
                won_lost_draw[:tied] = won_lost_draw[:tied] + 1
            elsif m.pointsThree > m.pointsOne
                won_lost_draw[:won] = won_lost_draw[:won] +1 
            elsif m.pointsThree < m.pointsOne
                won_lost_draw[:lost] = won_lost_draw[:lost] + 1
            end
        }
        won_lost_draw[:total] = won_lost_draw[:tied] + won_lost_draw[:won] + won_lost_draw[:lost]


        return won_lost_draw
    end
    def next_event
        #return MatchPlayer.where(player_id: self.id).collect{|mp| mp.event }.select{|e| e.status=="Open"}.sort_by{|e| e.updated_at }.first 
        return MatchPlayer.where(player_id: self.id).collect{|mp| mp.event }.select{|e| ((e.status=="Open") && (e.eventDate > Date.today) )}.sort_by{|e| e.updated_at }.first
    end
    def winRate(event_id = nil) 
        #returns the win ratio
        if event_id.nil?
            won_lost_draw_matches = self.won_lost_draw_matches
        else
            won_lost_draw_matches = self.won_lost_draw_matches(event_id)
        end

        
        ratio = 0.0
        player = Player.find(self.id)
        lost = player.won_lost_draw_matches[:lost].to_f
        won = player.won_lost_draw_matches[:won].to_f
        
        if lost == 0 && won == 0
            return 0
        elsif lost == 0 && won > 0
            return 1
        else            
            rate = won/won_lost_draw_matches[:total].to_f
            return rate * 100
        end 
    end
end

app/controllers/players_controller.rb
class PlayersController < ApplicationController
  before_action :authenticate_user!, except: %i[ new create ]
  before_action :check_user_role, except: %i[ new create dashboard]
  before_action :set_player, only: %i[ show edit update destroy ]
  

  # GET /players or /players.json
  def index
    @players = Player.all.sort_by{|p| p.totalScore}.reverse
  end

  # GET /players/1 or /players/1.json
  def show
  end

  # GET /players/new
  def new
    @player = Player.new
    @event = Event.find(params[:event_id]) if !params[:event_id].nil?
  end
  
  # GET /players/1/edit
  def edit    
  end
  
  
  # POST /players or /players.json
  def create
    @player = Player.new(player_params)
    @player.cellphone = @player.cellphone.gsub(/\s+/, "")
    respond_to do |format|
      if @player.save
        if !params[:event_id].nil? #entonces enrolamos al player
          mp = MatchPlayer.create(event_id: params[:event_id].to_i, player_id: @player.id)          
          if !mp.errors.messages.any?
            mp.setStatus
            mp.save!
            format.html { redirect_to match_player_url(mp), notice: "You have joined succesfully to the event"}
          end
        end
        format.html { redirect_to player_url(@player), notice: "Player was successfully created." }
        format.json { render :show, status: :created, location: @player }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @player.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /players/1 or /players/1.json
  def update
    clean_cellphone = params[:player][:cellphone].gsub(/\s+/, "")
    #player_params[:cellphone] = "11111"
    params[:player][:cellphone] = clean_cellphone
    #logger.debug "-------------params------> #{params[:player][:cellphone]}"
    respond_to do |format|
      if @player.update(player_params)
        format.html { redirect_to player_url(@player), notice: "Player was successfully updated." }
        format.json { render :show, status: :ok, location: @player }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @player.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /players/1 or /players/1.json
  def destroy
    @player.destroy

    respond_to do |format|
      format.html { redirect_to players_url, notice: "Player was successfully destroyed." }
      format.json { head :no_content }
    end
  end
  
  def dashboard
    if current_user.role == "Player"
      @player = Player.find(current_user.player_id)
    else
      @player = Player.find(params[:player_id])
    end
  end
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_player
      @player = Player.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def player_params
      params.require(:player).permit(:name, :category, :leftHanded, :birthDate, :eventScore, :totalScore, :cellphone, :image, :event_id)
    end
    
    def check_user_role
      case current_user.role        
        when "Player"
          respond_to do |format|
            format.html { redirect_to dashboard_player_path(current_user.player_id), notice: "...redirected to the dashboard page!"  }
            format.json { head :no_content }
          end        
      end
    end
end

app/helpers/players_helper.rb
module PlayersHelper
end

app/views/players/_form.html.erb
<div class="row">
    <div class="col-md-8">
        <div class="card">
            <div class="card-header pb-0">
                <div >                    
                    <%= link_to(players_path, class:"btn bg-gradient-primary ms-auto") do%>
                        <i class="fa fa-list-ol"></i>&nbsp;&nbsp;Players list
                    <%end%>
                </div>
            </div>
            <%= form_with(model: player) do |f| %>
              <% if player.errors.any? %>
                <div style="color: red">
                  <h2><%= pluralize(player.errors.count, "error") %> prohibited this event from being saved:</h2>

                  <ul>
                    <% player.errors.each do |error| %>
                      <li><%= error.full_message %></li>
                    <% end %>
                  </ul>
                </div>
              <% end %>

              <div class="card-body">                          
                  <div class="row">
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Player name</label>                              
                              <%= f.text_field :name, class: 'form-control', :required => true, placeholder: "Name of the player {Juan Perez Lopez}" %>
                          </div>
                      </div>
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Cellphone</label>                              
                              <%= f.text_field :cellphone, class: 'form-control', :required => true, placeholder: "This will be his identifier" %>
                          </div>
                      </div>
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Category</label>
                              <%= f.select :category, options_for_select(Player::CATEGORY.collect { |category|
                                                                         [category.to_i.ordinalize] }, player.category), {}, {id: 'select2_category',class:"form-control m-b",  required: true} %>
                          </div>
                      </div>
                      <div class="col-md-8">
                          <div class="form-group">                                                                                                                        
                              <%= f.label "Left handed", "Left handed", value: "true"  %>
                              <%= f.radio_button :leftHanded, true %>
                              <%= f.label "Right handed", "Right handed", value: "false" %>
                              <%= f.radio_button :leftHanded, false, checked: true %>
                          </div>
                      </div>
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Birth date</label>                              
                              <%= f.date_field :birthDate, class: 'form-control'%>
                          </div>
                      </div>
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Photo</label>                              
                              <%= f.file_field :image, class: 'form-control'%>
                          </div>
                      </div>
                      <%= hidden_field_tag 'event_id', @event.nil? ? nil:@event.id  %>                        
                  </div>
                  <hr class="horizontal dark">
                  <div class="form-group">
                    <div class="col-sm-4 col-sm-offset-2">                      
                      <%= button_tag(type: 'submit', data: {turbo: false}, class: "btn bg-gradient-success ms-auto") do %>
                        Save&nbsp;&nbsp;<i class="fa fa-database"></i>
                      <% end %>
                    </div>
                  </div>
                  
              </div>
            <% end %>

        </div>
    </div>                
</div>
<script type="text/javascript">
  // In your Javascript (external .js resource or <script> tag)
  $(document).ready(function() {
      //$('.js-example-basic-single').select2();
      $('#select2_category').select2();      
  });
</script>

app/views/players/_player.html.erb
 <div id="<%= dom_id player %>">
  <div class="row">
    <div class="col-md-8">
      <div class="card shadow-lg">
        <div class="card-body p-3">
          <div class="row gx-4">
            <div class="col-auto">
              <div class="avatar avatar-xl position-relative">
               <!-- >
                <%= image_tag("eduardogarcia.jpg", class: "w-100 border-radius-lg shadow-sm")%>
                -->
                <%if !player.image_attachment.nil?%>
                  <%= image_tag(player.image, class: "w-100 border-radius-lg shadow-sm")%>
                <%else%>
                  <%= image_tag("blank-profile-picture.jpg", class: "w-100 border-radius-lg shadow-sm")%>
                <%end%>
              </div>
            </div>
            <div class="col-auto my-auto">        
            <div class="h-100">
            <p class="h4">
              <%=player.name.titleize%> &nbsp;&nbsp;&nbsp;&nbsp; Total Points:&nbsp; <%=player.totalScore%> 
              <i class="ni ni-chart-bar-32 text-success text-sm opacity-10"></i>
            </p>                
                <p class="mb-0 font-weight-bold text-sm">
                  Category: <%=player.category.to_i.ordinalize%>
                </p>
              </div>
            </div>
            
              
          </div>
        </div>
      </div>
    </div>
    <div class="col-md-8">
      <br>
    </div>
    <div class="col-md-8">
      <div class="card">
        <div class="card-header pb-0">
          <div class="d-flex align-items-center">
            <p class="mb-0">Player Profile and Stats</p>
            <%= link_to(edit_player_path(@player), class:"btn bg-gradient-primary ms-auto") do%>
                <i class="fa fa-edit"></i>&nbsp;&nbsp;Edit
            <%end%>
          </div>
        </div>
        <div class="card-body">
          <p class="text-uppercase text-sm">Player Information</p>
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Lefthanded</label>
                <p class="text-uppercase text-sm"><%= player.leftHanded? ? 'Yes':'No' %></p>
                
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Cellphone</label>
                <p class="text-uppercase text-sm"><%= player.cellphone %></p>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Birth date</label>
                <%if !player.birthDate.nil?%>
                  <p class="text-uppercase text-sm"><%= player.birthDate.strftime("%d/%m/%Y")%> &nbsp;&nbsp;  (<%=player.age%> Years) </p>
                <%end%>
              </div>
            </div>          
          </div>

          <hr class="horizontal dark">
          <p class="text-uppercase text-sm">Player stats</p>
          <div class="row">
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Total Points</label>
                <p class="text-uppercase text-sm"><%=player.totalScore%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Events played</label>
                <p class="text-uppercase text-sm"><%=player.eventsPlayed%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Events won</label>
                <p class="text-uppercase text-sm"><%=player.scores.where(position: 1).count%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Points per event (Average)</label>
                <p class="text-uppercase text-sm"><%=player.average%></p>
              </div>
            </div>        
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">General rank</label>
                <p class="text-uppercase text-sm"><%=player.generalRank%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Category rank</label>
                <p class="text-uppercase text-sm"><%=player.categoryRank%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Won matches</label>
                <p class="text-uppercase text-sm"><%=player.won_lost_draw_matches[:won]%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Lost matches</label>
                <p class="text-uppercase text-sm"><%=player.won_lost_draw_matches[:lost]%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Tied matches</label>
                <p class="text-uppercase text-sm"><%=player.won_lost_draw_matches[:tied]%></p>
              </div>
            </div>
            <div class="col-md-3">
              <div class="form-group">
                <label for="example-text-input" class="form-control-label">Win rate</label>
                <p class="text-uppercase text-sm"><%=player.winRate%>%</p>
              </div>
            </div>

            <div class="card-header pb-0">
          <div class="d-flex align-items-center">            
            <%= link_to(players_path, class:"btn bg-gradient-primary ms-auto") do%>
                <i class="fa fa-list-ol"></i>&nbsp;&nbsp;Player list
            <%end%>
          </div>
        </div>
          </div>      
        </div>
      </div>
    </div>
  
  </div>
</div>

app/views/players/edit.html.erb
<h3 style= "color: white">Editing player</h3>
<%= render "form", player: @player %>

app/views/players/index.html.erb
<div class="row">
        <div class="col-12">
          <div class="card mb-4">
          <div class="d-flex px-2 py-1">
          </div>
            <div class="card-header pb-0">
              <div class="d-flex align-items-center">
                <p class="h4">Players list   &nbsp;&nbsp;&nbsp;<small> [<%=@players.count%> Total]</small></p>
                <%= link_to(new_player_path, class: "btn bg-gradient-primary ms-auto") do %>
                  <i class="fa fa-plus-square"></i> New Player
                <% end %>
              </div>
            </div>
            <div class="card-body px-0 pt-0 pb-2">
              <div class="table-responsive p-6">
                <table id= "players_table" class="hover compact">
                  <thead>
                    <tr>
                      
                      <th class="text-uppercase text-primary text-s font-weight-bolder">ID</th>
                      <th class="text-uppercase text-primary text-s font-weight-bolder ps-2">Name</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">Category</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">Cellphone</th>
                      <th class="text-center text-uppercase text-primary text-s font-weight-bolder ">Hand</th>                      
                      <th class="text-secondary opacity-7"></th>                      
                    </tr>
                  </thead>
                  <tbody>
                  <% @players.each do | player|%>
                    <tr>
                      <td>
                        <div class="d-flex px-2 py-1">                          
                          <div class="d-flex flex-column justify-content-right">
                            <h6 class="mb-0 text-sm"><%=player.id%></h6>                            
                          </div>
                        </div>
                      </td>
                      <td>                         
                        <div class="d-flex px-2 py-1">
                          <div >
                            <%if !player.image_attachment.nil?%>
                              <%= image_tag(player.image, class: "avatar avatar-sm me-3") if !player.image_attachment.nil? %>
                            <%else%>
                              <%= image_tag("blank-profile-picture.jpg", class: "avatar avatar-sm me-3")%>
                            <%end%>                            
                          </div>
                          <div class="d-flex flex-column justify-content-center">
                            <h6 class="mb-0 text-sm"><%= link_to player.name.titleize, dashboard_player_path(player), class: "text-xs font-weight-bold mb-0" %></h6>
                            <p class="text-xs text-secondary mb-0">Total points: <%=player.totalScore%></p>
                          </div>
                        </div>

                        
                      </td>
                      <td class="align-middle text-center">
                        <span class="text-secondary text-xs font-weight-bold"><%=player.category.to_i.ordinalize%></span>
                      </td>                      
                      <td class="align-middle text-center">
                        <span class="text-secondary text-xs font-weight-bold"> <%=player.cellphone%></span>
                      </td>
                      <td class="align-middle text-center">
                       <%= player.leftHanded? ? 'Left':'Right' %>
                      </td>                      
                      <td>
                        <div class="dropdown">
                          <button type="button" class="btn btn-sm bg-gradient-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
                            Action
                          </button>
                          <ul class="dropdown-menu px-2 py-3" aria-labelledby="dropdownMenuButton">
                            <li>
                              <%= link_to(edit_player_path(player), class:"dropdown-item border-radius-md") do%>
                                Edit&nbsp;&nbsp;<i class="fa fa-edit"></i>
                              <% end %>
                            </li>
                            <li>
                              <%= link_to(player, class:"dropdown-item border-radius-md") do %>
                                Show&nbsp;&nbsp;<i class="fa fa-eye"></i>
                              <%end%>
                            </li>
                            <li>
                              <%= link_to(player, data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'}, class:"dropdown-item border-radius-md") do %>
                                Delete&nbsp;&nbsp;<i class="fa fa-trash-o"></i>
                              <%end%>
                            </li>
                            <li>
                              <%= link_to(player_scores_path(player), class:"dropdown-item border-radius-md") do %>
                                Scores&nbsp;&nbsp;<i class="fa fa-bar-chart"></i>
                              <%end%>
                            </li>
                          </ul>
                        </div>                        
                      </td>                      
                    </tr>
                    <%end%>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
<script type="text/javascript">
  // In your Javascript (external .js resource or <script> tag)
    $(document).ready(function() {    
    $('#players_table').DataTable();        
  });
</script>

app/views/players/new.html.erb
<h3 style= "color: white">New player</h3>

<%= render "form", player: @player %>

app/views/players/show.html.erb
<%= render @player %>